PRO GKVs1D::RemoveShift, ly=ly
;
; Purpose:
;
;	This proceedure removes discontinuities in the data in 'self'
;	of size 'ly' which may result from periodic boundary conditions.
;
; Written by W.M. Nevins
;	12/17/01
;
IF(N_ELEMENTS(ly) NE 1) THEN RETURN
ly = ABS(ly)
self -> restrict
values = *self.values
gridValues = *self.grid1.values
irange = self.grid1.irange

gridValuesSq = gridValues*GridValues
epsilon = MIN(gridValuesSq, ix0)	; ix0 is now index into Gridvalues array of its element closest to zero
value0 = values[ix0]

shiftUp = (values - SHIFT(values, 1)) GT ly/2.
shiftUp[0] = 0

shiftDown = (values - SHIFT(values,1)) LT -ly/2.
shiftDown[0] = 0

netshift = FLOAT(shiftUp) - FLOAT(shiftDown)

shifts = ly*TOTAL(netShift, /CUMULATIVE)

values = values - shifts

IF( (ix0 NE irange[0]) AND (ix0 NE irange[1]) ) THEN values = values-values[ix0]

PTR_FREE, self.values
self.values = PTR_NEW(values)
vmin = GKVsd_MIN(values, MAX=vmax)
self.vrange=[vmin,vmax]
RETURN
END  ;  ****** GKVs1D::RemoveShift ******  ;

PRO GKVs2D::RemoveShift, ly=ly
;
; Purpose:
;
;	Dummy routine to head off calls to GKVs1D::RemoveShift
;	on objects with dimensionality greate than 1.
;
;  Written by W.M. Nevins
;	12/17/01
;
MESSAGE, "RemoveShift only implimented in 1-D", /INFORMATIONAL
RETURN
END  ;  ****** GKVs2D::RemoveShift ******  ;