pro history, svdir, nm

!P.Charthick=3.0
!P.Charsize=1.3
!X.Charsize=1.3
!Y.Charsize=1.3
Thick_int=2.0
!P.Thick=Thick_int
!X.Thick=3.0
!Y.Thick=3.0

ind=lonarr(4)
infl=svdir+'hist.out'
infl=strcompress(infl,/remove_all)

openr, 1, infl
readf, 1, ind
modes=intarr(3*ind(2))
readf, 1, modes
print, modes
nm=ind(1)
print, "nm=", nm
pmodehis=complexarr(ind(2),ind(1))
te=fltarr(ind(1))
ke=fltarr(ind(0),ind(1))
pfl=fltarr(ind(0),ind(1))
efl=fltarr(ind(0),ind(1))
fe=fltarr(ind(1))
rmsphi=fltarr(ind(1))
timex=findgen(ind(1))*ind(3)

holdpmode=complexarr(ind(2)*ind(1))
holdke=fltarr(ind(0)*ind(1))
holdpfl=fltarr(ind(0)*ind(1))
holdefl=fltarr(ind(0)*ind(1))

readf, format='(2e12.5)', 1, holdpmode
for mm=0,ind(2)-1 do begin
  for n=0,ind(1)-1 do begin
    pmodehis(mm,n)=holdpmode(n+mm*ind(1))
  endfor
endfor

readf, format='(e12.5)', 1, holdke
readf, format='(e12.5)', 1, holdpfl
readf, format='(e12.5)', 1, holdefl
for m=0,ind(0)-1 do begin
  for n=0,ind(1)-1 do begin
    ke(m,n)=holdke(n+m*ind(0))
    pfl(m,n)=holdpfl(n+m*ind(0))
    efl(m,n)=holdefl(n+m*ind(0))
    te(n)=te(n)+ke(m,n)
  endfor
endfor

readf, format='(e12.5)', 1, fe
readf, format='(e12.5)', 1, rmsphi

for n=0,ind(1)-1 do begin
  te(n)=te(n)+fe(n)
endfor

close, 1

;loadct, 0

set_plot, 'ps'
!p.multi=[0,2,3,0]
flnm=svdir+'hist1.ps'
;device, file=flnm, /encapsulated, xsize=21, ysize=27
device, file=flnm, xoffset=0.5, yoffset=0.5, xsize=20, ysize=26
plot, timex, ke(0,0:ind(1)-1), title='kinetic energy vs. t', $
  xstyle=1, ystyle=1
plot, timex, fe, title='field energy vs. t', $
  xstyle=1, ystyle=1
plot, timex, te, title='total energy vs. t', $
  xstyle=1, ystyle=1
plot, timex, rmsphi, title='rmsphi vs. t', $
  xstyle=1, ystyle=1
plot, timex, pfl(0,0:ind(1)-1), title='particle flux', $
  xstyle=1, ystyle=1
plot, timex, efl(0,0:ind(1)-1), title='energy flux', $
  xstyle=1, ystyle=1, ylog=0
device, /close

!p.multi=[0,3,4,0]
flnm=svdir+'hist2.ps'
;device, file=flnm, /encapsulated, xsize=21.5, ysize=27
device, file=flnm, xsize=21.5, ysize=27
for m=0,ind(2)-1 do begin
  ttl='phi mode (l,m,n) '
  ttl=ttl+string(modes(3*m))+$
    string(modes(3*m+1))+string(modes(3*m+2))
  ttl=strcompress(ttl)
  ymin=fltarr(3)
  ymax=fltarr(3)
  ymin(0)=min(imaginary(pmodehis(m,0:ind(1)-1)))
  ymin(1)=min(float(pmodehis(m,0:ind(1)-1)))
  ymin(2)=min(abs(pmodehis(m,0:ind(1)-1)))
  ymax(0)=max(imaginary(pmodehis(m,0:ind(1)-1)))
  ymax(1)=max(float(pmodehis(m,0:ind(1)-1)))
  ymax(2)=max(abs(pmodehis(m,0:ind(1)-1)))
  plot, timex, float(pmodehis(m,0:ind(1)-1)), $
    title=ttl,$
    subtitle='phi mode history', $
    xstyle=1, ystyle=1, $
    yrange=[min(ymin),max(ymax)]
  oplot, timex, abs(pmodehis(m,0:ind(1)-1)), $
    linestyle=2
  oplot, timex, imaginary(pmodehis(m,0:ind(1)-1)), $
    linestyle=1
  plot, timex, alog(abs(pmodehis(m,0:ind(1)-1))), $
    title=ttl,$
    subtitle='amp. phi mode history', $
    xstyle=1, ystyle=1, linestyle=0
  plot, timex, abs(fft(pmodehis(m,0:ind(1)-1))/ind(1)), $
    title=ttl,$
    subtitle='power spectrum', $
    xstyle=1, ystyle=1
endfor
device, /close

return
end


pro pltgridxy, svdir, grdin, nm

!P.Charthick=3.0
!P.Charsize=1.3
!X.Charsize=1.3
!Y.Charsize=1.3
Thick_int=2.0
!P.Thick=Thick_int
!X.Thick=3.0
!Y.Thick=3.0

mctl=grdin+' x-y, z=lz/2'
mltl='x, z=lz/2, y=ly/2'

ind = lonarr(5)
infl=svdir+grdin+'xy.out'
infl=strcompress(infl,/remove_all)
openr, 1, infl
readf, 1,ind
print, ind
im=ind(0)
jm=ind(1)
nplot=ind(3)
;tm=ind(2)
tm=fix(nm/nplot)+1
dt=ind(4)
holdgrd=dblarr((im+1)*(jm+1)*tm)
grdq=dblarr(im+1,jm+1,tm)
readf, format='(e12.5)',1,holdgrd
close, 1


labs=[1,0,1,0,1,0,1,0,1,0,1,0,1,0,1]

for k=0,tm-1 do begin
  for j=0,jm do begin
    for i=0,im do begin
      grdq(i,j,k)=holdgrd(i+j*(im+1)+k*(im+1)*(jm+1))
    endfor
  endfor
endfor

loadct, 32

!p.multi = [0,2,3,0,0]
set_plot, 'ps'
flnm=svdir+grdin+'xy_pg0.ps'
;device, file=flnm, /color, /encapsulated, $
device, file=flnm, /color, bits=8, xoffset=0., yoffset=0.0, xsize=21, ysize=24.5

for k=0,tm-1 do begin
  rmax=max(grdq(0:im,0:jm,k))
  rmin=min(grdq(0:im,0:jm,k))
  levs=dindgen(15)
  rran=rmax-rmin
  levs=rran/15*levs
  levs=levs+rmin
  if ((levs(0) eq 0) and (levs(14) eq 0)) then levs=dindgen(15) 
  if ((k mod 3) eq 0.) and (k ne 0) then begin
    device, /close
    flnm=svdir+grdin+'xy_pg'+$
	string(fix((k+1)/3))+'.ps
    flnm=strcompress(flnm,/remove_all)
    ;device, file=flnm, /color, /encapsulated,$
    device, file=flnm, /color, $
      bits=8, xoffset=0., yoffset=0.0, xsize=21, ysize=24.5
  endif
  mtl=mctl + $
;      string(dt*(k+1)*nplot)
      string(dt*(k)*nplot)
  mtl=strcompress(mtl)
  ytl='contour intervals of' + $
    string(rran/15*1e5)+'e-05'
  ytl=strcompress(ytl)
  stl='data ranges from' + $
    string(rmin*1e5)+' to'+string(rmax*1e5)+$
    'e-05'
  stl=strcompress(stl)
;  if ((levs(0) ne 0) and (levs(14) ne 0)) then begin
    contour, grdq(0:im,0:jm,k), levels=levs, $
         xstyle=1, ystyle=1, charsize=.8, $
	 /fill, c_colors=indgen(15)*5, $
  	 title=mtl, subtitle=stl, ytitle=ytl
    contour, grdq(0:im,0:jm,k), $;levels=levs, $
         c_labels=labs, xstyle=1, ystyle=1, $
	 c_linestyle=(levs lt 0.0), /overplot
    mtl=mltl
    plot, grdq(0:im,jm/2-1,k), xstyle=1, title=mtl
;  endif
endfor

device, /close
loadct, 0

return
end

pro pltgridxz, svdir, grdin, nm

!P.Charthick=3.0
!P.Charsize=1.3
!X.Charsize=1.3
!Y.Charsize=1.3
Thick_int=2.0
!P.Thick=Thick_int
!X.Thick=3.0
!Y.Thick=3.0


mctl=grdin + 'x-z, y=lz/2'
mltl='z, x=lx/2, y=ly/2'

ind = lonarr(5)
infl=svdir+grdin+'xz.out'
infl=strcompress(infl,/remove_all)
openr, 1, infl
readf, 1,ind
print, ind
im=ind(0)
jm=ind(1)
tm=ind(2)
nplot=ind(3)
tm=fix(nm/nplot)+1
dt=ind(4)
holdgrd=dblarr((im+1)*(jm+1)*tm)
grdq=dblarr(im+1,jm+1,tm)
readf, format='(e12.5)',1,holdgrd
close, 1


labs=[1,0,1,0,1,0,1,0,1,0,1,0,1,0,1]

for k=0,tm-1 do begin
  for j=0,jm do begin
    for i=0,im do begin
      grdq(i,j,k)=holdgrd(i+j*(im+1)+k*(im+1)*(jm+1))
    endfor
  endfor
endfor

loadct, 32

!p.multi = [0,2,3,0,0]
set_plot, 'ps'
flnm=svdir+grdin+'xz_pg0.ps'
device, file=flnm, /color, $
;device, file=flnm, /color, /encapsulated, $
      bits=8, xoffset=0., yoffset=0.0, xsize=21, ysize=24.5
for k=0,tm-1 do begin
  rmax=max(grdq(0:im,0:jm,k))
  rmin=min(grdq(0:im,0:jm,k))
  levs=dindgen(15)
  rran=rmax-rmin
  levs=rran/15*levs
  levs=levs+rmin
  if ((levs(0) eq 0) and (levs(14) eq 0)) then levs=dindgen(15)
  if ((k mod 3) eq 0.) and (k ne 0) then begin
    device, /close
    flnm=svdir+grdin+'xz_pg'+$
	string(fix((k+1)/3))+'.ps
    flnm=strcompress(flnm,/remove_all)
    ;device, file=flnm, /color, /encapsulated,$
    device, file=flnm, /color, $
      bits=8, xoffset=0., yoffset=0.0, xsize=21, ysize=24.5
  endif
  mtl=mctl + $
      string(dt*(k+1)*nplot)
  mtl=strcompress(mtl)
  ytl='contour intervals of' + $
    string(rran/15*1e5)+'e-05'
  ytl=strcompress(ytl)
  stl='data ranges from' + $
    string(rmin*1e5)+' to'+string(rmax*1e5)+$
    'e-05'
  stl=strcompress(stl)
 ; if ((levs(0) ne 0) and (levs(14) ne 0)) then begin
    contour, grdq(0:im,0:jm,k), levels=levs, $
         xstyle=1, ystyle=1, charsize=.8, $
	 /fill, c_colors=indgen(15)*5, $
  	 title=mtl, subtitle=stl, ytitle=ytl
    contour, grdq(0:im,0:jm,k), $;levels=levs, $
         c_labels=labs, xstyle=1, ystyle=1, $
	 c_linestyle=(levs lt 0.0), /overplot
    mtl=mltl
    plot, grdq(im/2-1,0:jm,k), xstyle=1, title=mtl
 ; endif
endfor

device, /close
loadct, 0

return
end


pro pltgridr, svdir, gridin, nm

!P.Charthick=2.0
!P.Charsize=1.3
!X.Charsize=1.3
!Y.Charsize=1.3
Thick_int=2.0
!P.Thick=Thick_int
!X.Thick=3.0
!Y.Thick=3.0


mctl=gridin+'flux-surface average'
mltl=gridin+'flux-surface-avged vs. x'

ind = lonarr(4)
infl=svdir+gridin+'r.out'
infl=strcompress(infl,/remove_all)
openr, 1, infl
readf, 1,ind
print, ind
im=ind(0)
;tm=ind(1)
nplot=ind(2)
tm=fix(nm/nplot)+1
dt=ind(3)
holdgrd=dblarr((im+1)*tm)
aphir=dblarr(im+1,tm)
readf, format='(e12.5)',1,holdgrd
close, 1



for k=0,tm-1 do begin
  for i=0,im do begin
      aphir(i,k)=holdgrd(i+k*(im+1))
  endfor
endfor

loadct, 32

!p.multi = [0,2,3,0,0]
set_plot, 'ps'
flnm=svdir+gridin+'r_pg0.ps'
device, file=flnm, /color, $
;device, file=flnm, /color, /encapsulated, $
      bits=8, xoffset=0., yoffset=0.0, xsize=21, ysize=24.5
for k=0,tm-1 do begin
  if ((k mod 6) eq 0.) and (k ne 0) then begin
    device, /close
    flnm=svdir+gridin+'r_pg'+$
	string(fix((k+1)/6))+'.ps
    flnm=strcompress(flnm,/remove_all)
    ;device, file=flnm, /color, /encapsulated,$
    device, file=flnm, /color, $
      bits=8, xoffset=0., yoffset=0.0, xsize=21, ysize=24.5
  endif
  mtl=mctl + ' t = ' + $
      string(dt*(k+1)*nplot)
  mtl=strcompress(mtl)
  plot, aphir(0:im,k), xstyle=1, title=mtl,$
	subtitle=mltl

endfor

device, /close
loadct, 0

return
end

pro diag

svdir='/home/sparker/diag/small/'
;svdir='d:\diag\'

history, svdir, nm

pltgridxy, svdir, 'phi', nm
pltgridxz, svdir, 'phi', nm
pltgridr, svdir, 'aphi', nm

pltgridxy, svdir, 'rho', nm
pltgridxz, svdir, 'rho', nm

pltgridxy, svdir, 'dne', nm
pltgridxz, svdir, 'dne', nm

pltgridxy, svdir, 'dni', nm
pltgridxz, svdir, 'dni', nm

;pltgridxy, svdir, 'ez_', nm
;pltgridxz, svdir, 'ez_', nm

pltgridxy, svdir, 'apa', nm
pltgridxz, svdir, 'apa', nm
pltgridr, svdir, 'aapa', nm

pltgridxy, svdir, 'upa', nm
pltgridxz, svdir, 'upa', nm
pltgridr, svdir, 'aupa', nm

return
end


