FUNCTION GKVs3D::PhiHist
;
; Purpose:
;
;		This proceedure expects a pg3eq phihist object 
;		(the mode history from the .h file).  It returns
;		an array of GKVs1D objects containing the time
;		histories of each of the nModes modes contained
;		in the PhiHist object.
;		
;	Arguments:
;
;			None
;
;	Keywords:
;
;			None
;
; Written by W.M. Nevins
;	9/28/00
;
temp = self -> MakeCopy()
temp -> Restrict
valuePtr = temp -> GetValues()
values = *valuePtr
info = SIZE(values)
;
; 'values' are indicexed: values[r/i, nModes, t]
;
nModes = info[2]
nt = info[3]
modeNumbers = *(temp.Grid2.values)
modeNumbers = FIX(modeNumbers)
modeText = STRARR(nModes)
FOR i=0,nModes-1 DO modeText[i] = STRING(modeNumbers[i], FORMAT='(I2)')
modeText = STRCOMPRESS(modeText, /REMOVE_ALL)
result = OBJARR(nModes)
tGrid = temp.Grid3
modeObj = {GKVs1D}
FOR i=0, N_TAGS(modeObj)-1  DO modeObj.(i) = temp.(i)
modeObj.mnemonic = 'Phi_'
modeObj.title = '!4u!X!Lk!iy!N'
indices = ["N!Ly!N=", "*"]
modeObj.units = '(L!LT!N/!4q!X!Ls!N)(T/e)'


FOR i=0,nModes-1 DO BEGIN
	thisMode = modeObj
	thisMode.mnemonic=modeObj.mnemonic + modeText[i]
	modeIndices = indices + [modeText[i],'']
	thisMode.indices = PTR_NEW(modeIndices)
	modevalues=COMPLEX(values[0,i,*], values[1,i,*])
	thisMode.values = PTR_NEW(modevalues)
	thisMode.Grid1 = GKVsd_GridCopy(tGrid)
	result[i] = OBJ_NEW('GKVs1D', thisMode)
ENDFOR
RETURN, result
END ; ****** GKVs3D::PhiHist ****** ;
